*   oSheet.insertRange(, _)
#define ooCellInsertModeNONE		0  && com.sun.star.sheet.CellInsertMode NONE
#define ooCellInsertModeDOWN		1  && com.sun.star.sheet.CellInsertMode DOWN
#define ooCellInsertModeRIGHT		2  && com.sun.star.sheet.CellInsertMode RIGHT
#define ooCellInsertModeROWS		3  && com.sun.star.sheet.CellInsertMode ROWS
#define ooCellInsertModeCOLUMNS		4  && com.sun.star.sheet.CellInsertMode COLUMNS

* enum CellDeleteMode. Is used to specify how remaining cells are moved when cells are deleted.
*   oSheet.removeRange(, _)
#define ooCellDeleteModeNONE		0  && com.sun.star.sheet.CellDeleteMode.NONE
#define ooCellDeleteModeUP			1  && com.sun.star.sheet.CellDeleteMode.UP
#define ooCellDeleteModeLEFT		2  && com.sun.star.sheet.CellDeleteMode.LEFT
#define ooCellDeleteModeROWS		3  && com.sun.star.sheet.CellDeleteMode.ROWS
#define ooCellDeleteModeCOLUMNS		4  && com.sun.star.sheet.CellDeleteMode.COLUMNS

#define ooCellHoriJustifyLEFT		1  && com.sun.star.table.CellHoriJustify LEFT
#define ooCellHoriJustifyCENTER		2  && com.sun.star.table.CellHoriJustify CENTER
#define ooCellHoriJustifyRIGHT		3  && com.sun.star.table.CellHoriJustify RIGHT

#define ooDocumentZoomTypeOPTIMAL			0  && com.sun.star.view.DocumentZoomType OPTIMAL
#define ooDocumentZoomTypePAGE_WIDTH		1  && com.sun.star.view.DocumentZoomType PAGE_WIDTH
#define ooDocumentZoomTypeENTIRE_PAGE		2  && com.sun.star.view.DocumentZoomType ENTIRE_PAGE
#define ooDocumentZoomTypeBY_VALUE			3  && com.sun.star.view.DocumentZoomType BY_VALUE
#define ooDocumentZoomTypePAGE_WIDTH_EXACT	4  && com.sun.star.view.DocumentZoomType PAGE_WIDTH_EXACT

* constants group PosSize. These constants are used to flag the parameters of a rectangle.
#define ooPosSizeX					1   && com.sun.star.awt.PosSize.X       flags the x-coordinate.
#define ooPosSizeY					2   && com.sun.star.awt.PosSize.Y       flags the y-coordinate.
#define ooPosSizeWIDTH				4   && com.sun.star.awt.PosSize.WIDTH   flags the width.
#define ooPosSizeHEIGHT				8   && com.sun.star.awt.PosSize.HEIGHT  flags the height.
#define ooPosSizePOS				3   && com.sun.star.awt.PosSize.POS     flags the x- and y-coordinate.
#define ooPosSizeSIZE				12  && com.sun.star.awt.PosSize.SIZE    flags the width and height.
#define ooPosSizePOSSIZE			15  && com.sun.star.awt.PosSize.POSSIZE flags the x- and y-coordinate, width and height.

* enum WindowClass. Specifies the class of a window.
#define ooWindowClassTOP			0	&& com.sun.star.awt.WindowClass.TOP       specifies a top level window on the desktop. It is also a container.
#define ooWindowClassMODALTOP		1	&& com.sun.star.awt.WindowClass.MODALTOP  is a modal top level window on the desktop. It is also a container.
#define ooWindowClassCONTAINER		2	&& com.sun.star.awt.WindowClass.CONTAINER is a container that may contain other components. It is not a top window.
#define ooWindowClassSIMPLE			3	&& com.sun.star.awt.WindowClass.SIMPLE    is the simplest window. It can be a container.

* constants group WindowAttribute. These values are used to specify the decorations of a window. IMPORTANT: These constands have to be disjunct with constants in VclWindowPeerAttribute.
#define ooWindowAttributeSHOW			 1    && com.sun.star.awt.WindowAttribute.SHOW            specifies that the window is initially visible.
#define ooWindowAttributeFULLSIZE		 2    && com.sun.star.awt.WindowAttribute.FULLSIZE        specifies that the window fills the complete desktop area.
#define ooWindowAttributeOPTIMUMSIZE	 4    && com.sun.star.awt.WindowAttribute.OPTIMUMSIZE     specifies that the window is optimum size.
#define ooWindowAttributeMINSIZE		 8    && com.sun.star.awt.WindowAttribute.MINSIZE         specifies that the window is minimum size.
#define ooWindowAttributeBORDER			 16   && com.sun.star.awt.WindowAttribute.BORDER          specifies that the window has visible borders.
#define ooWindowAttributeSIZEABLE		 32   && com.sun.star.awt.WindowAttribute.SIZEABLE        specifies that the size of the window can be changed by the user.
#define ooWindowAttributeMOVEABLE		 64   && com.sun.star.awt.WindowAttribute.MOVEABLE        specifies that the window can be moved by the user.
#define ooWindowAttributeCLOSEABLE		 128  && com.sun.star.awt.WindowAttribute.CLOSEABLE       specifies that the window can be closed by the user. 
#define ooWindowAttributeSYSTEMDEPENDENT 256  && com.sun.star.awt.WindowAttribute.SYSTEMDEPENDENT [ DEPRECATED ] specifies that the window should support the XSystemDependentWindowPeer interface.

* constants group SystemPointer. Specifies the shape of a mouse pointer.
#define ooSystemPointerARROW		0	&& com.sun.star.awt.SystemPointer.ARROW		specifies the normal arrow-like mouse pointer
#define ooSystemPointerINVISIBLE	1	&& com.sun.star.awt.SystemPointer.INVISIBLE	specifies an invisible mouse pointer
#define ooSystemPointerWAIT			2	&& com.sun.star.awt.SystemPointer.WAIT		specifies a waiting symbol as a mouse pointer (for example hourglas)
#define ooSystemPointerTEXT			3
#define ooSystemPointerHELP			4
#define ooSystemPointerCROSS		5
#define ooSystemPointerMOVE			6
#define ooSystemPointerNSIZE		7
#define ooSystemPointerSSIZE		8
#define ooSystemPointerWSIZE		9
#define ooSystemPointerESIZE		10
#define ooSystemPointerNWSIZE		11
#define ooSystemPointerNESIZE		12
#define ooSystemPointerSWSIZE		13
#define ooSystemPointerSESIZE		14
#define ooSystemPointerWINDOW_NSIZE	15
#define ooSystemPointerWINDOW_SSIZE	16
#define ooSystemPointerWINDOW_WSIZE	17
#define ooSystemPointerWINDOW_ESIZE	18
#define ooSystemPointerWINDOW_NWSIZE	19
#define ooSystemPointerWINDOW_NESIZE	20
#define ooSystemPointerWINDOW_SWSIZE	21
#define ooSystemPointerWINDOW_SESIZE	22
#define ooSystemPointerHSPLIT		23
#define ooSystemPointerVSPLIT		24
#define ooSystemPointerHSIZEBAR		25
#define ooSystemPointerVSIZEBAR		26
#define ooSystemPointerHAND			27
#define ooSystemPointerREFHAND		28
#define ooSystemPointerPEN			29
#define ooSystemPointerMAGNIFY		30
#define ooSystemPointerFILL			31
#define ooSystemPointerROTATE		32
#define ooSystemPointerHSHEAR		33
#define ooSystemPointerVSHEAR		34
#define ooSystemPointerMIRROR		35
#define ooSystemPointerCROOK		36
#define ooSystemPointerCROP			37
#define ooSystemPointerMOVEPOINT	38
#define ooSystemPointerMOVEBEZIERWEIGHT	39
#define ooSystemPointerMOVEDATA		40
#define ooSystemPointerCOPYDATA		41
#define ooSystemPointerLINKDATA		42
#define ooSystemPointerMOVEDATALINK	43
#define ooSystemPointerCOPYDATALINK	44
#define ooSystemPointerMOVEFILE		45
#define ooSystemPointerCOPYFILE		46
#define ooSystemPointerLINKFILE		47
#define ooSystemPointerMOVEFILELINK	48
#define ooSystemPointerCOPYFILELINK	49
#define ooSystemPointerMOVEFILES	50
#define ooSystemPointerCOPYFILES	51
#define ooSystemPointerNOTALLOWED	52
#define ooSystemPointerDRAW_LINE	53
#define ooSystemPointerDRAW_RECT	54
#define ooSystemPointerDRAW_POLYGON	55
#define ooSystemPointerDRAW_BEZIER	56
#define ooSystemPointerDRAW_ARC		57
#define ooSystemPointerDRAW_PIE		58
#define ooSystemPointerDRAW_CIRCLECUT	59
#define ooSystemPointerDRAW_ELLIPSE	60
#define ooSystemPointerDRAW_FREEHAND	61
#define ooSystemPointerDRAW_CONNECT	62
#define ooSystemPointerDRAW_TEXT	63
#define ooSystemPointerDRAW_CAPTION	64
#define ooSystemPointerCHART		65
#define ooSystemPointerDETECTIVE	66
#define ooSystemPointerPIVOT_COL	67
#define ooSystemPointerPIVOT_ROW	68
#define ooSystemPointerPIVOT_FIELD	69
#define ooSystemPointerCHAIN		70
#define ooSystemPointerCHAIN_NOTALLOWED	71

#define ooNumberFormatALL        0    && selects all number formats.   
#define ooNumberFormatDEFINED    1    && selects only user-defined number formats.   
#define ooNumberFormatDATE       2    && selects date formats. (com.sun.star.util.NumberFormat.DATE)
#define ooNumberFormatTIME       4    && selects time formats.   
#define ooNumberFormatCURRENCY   8    && selects currency formats.   
#define ooNumberFormatNUMBER     16   && selects decimal number formats.   
#define ooNumberFormatSCIENTIFIC 32   && selects scientific number formats.   
#define ooNumberFormatFRACTION   64   && selects number formats for fractions.   
#define ooNumberFormatPERCENT    128  && selects percentage number formats.   
#define ooNumberFormatTEXT       256  && selects text number formats.   
#define ooNumberFormatDATETIME   6    && selects number formats which contain date and time.   
#define ooNumberFormatLOGICAL    1024 && selects boolean number formats.   
#define ooNumberFormatUNDEFINED  2048 && is used as a return value if no format exists. 


************************************************************************************************
*	    OpenOffice.org.
*
* Public API
* High level routines.
************************************************************************************************

*  .t.,  OpenOffice.org , .f. -  
FUNCTION OOoIsInstalled()
	LOCAL oServiceManager
	oServiceManager = .NULL.
	LOCAL cOldErrHandler
	cOldErrHandler = ON( "ERROR" )
	
	ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
	oServiceManager = OOoGetServiceManager()
	ON ERROR &cOldErrHandler
	
	* If we could create a Service Manager, then OpenOffice.org must be installed.
	RETURN NOT ISNULL( oServiceManager )
	ENDFUNC
	
*   .
FUNCTION OOoCreateNewWriterDocument()
	LOCAL oWriterDoc
	oWriterDoc = OOoOpenURL( "private:factory/swriter" )
	RETURN oWriterDoc
	ENDFUNC
	
*    Calc
FUNCTION OOoCreateNewCalcDocument()
	LOCAL oCalcDoc
	oCalcDoc = OOoOpenURL( "private:factory/scalc" )
	RETURN oCalcDoc
	ENDFUNC
	
*    
FUNCTION OOoOpenFile( cFilename )
	LOCAL cURL
	
	*	   UNIX 
	cURL = "file:///" + CHRTRAN( cFilename, "\", "/" )
	
	LOCAL oDoc
	oDoc = OOoOpenURL( cURL )
	RETURN oDoc
	ENDFUNC
	
*  
PROCEDURE PrintExperiment( oDoc )
	LOCAL ARRAY aArgs[1]
	aArgs[1] = OOoPropertyValue( "CopyCount", 1, -1, 0 )
*
    aArgs[1] = OOoPropertyValue( "Collate", .F. )
	oDoc.Print( @ aArgs )
	ENDPROC
	
*   
PROCEDURE OOoTerminateProgram()
	LOCAL oDesktop
	oDesktop = OOoGetDesktop()
	oDesktop.Terminate()
	=__OOoReleaseCachedVars()
	ENDPROC
	
	
**********************************************************************************************************
**********************************************************************************************************
*	   
*---------------------------------------------------------------------------------------------------------

*	   .
PROCEDURE DoNothing__ErrorHandler( pnError, pcErrMessage, pnLineNo, pcProgramFileSys16, pcProgram, pcErrorParamSys2018 )
ENDPROC


*   service manager object.    ,    .
FUNCTION OOoGetServiceManager()
	IF (TYPE([goOOoServiceManager])!="O")  OR  ISNULL( goOOoServiceManager )
		PUBLIC goOOoServiceManager
		goOOoServiceManager = CREATEOBJECT( "Com.Sun.Star.ServiceManager.1" )
	ENDIF
	RETURN goOOoServiceManager
	ENDFUNC
	
	
*  -   /.  Sugar coated routine to ask the service manager to create you an instance of some other OpenOffice.org UNO object.
FUNCTION OOoServiceManager_CreateInstance( cServiceName )
	LOCAL oServiceManager
	oServiceManager = OOoGetServiceManager()
	LOCAL oInstance
	oInstance = .NULL.
	LOCAL cOldErrHandler
	cOldErrHandler = ON( "ERROR" )
	ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
	
	oInstance = oServiceManager.createInstance( cServiceName )
	ON ERROR &cOldErrHandler
	IF ISNULL( oInstance )
		=__OOoReleaseCachedVars()
		oServiceManager = OOoGetServiceManager()
		oInstance = oServiceManager.createInstance( cServiceName )
	ENDIF
	RETURN oInstance
	ENDFUNC
	
*      . Return the OpenOffice.org desktop object. Cache it in a global variable. Create it if not already cached.
FUNCTION OOoGetDesktop()
	IF (TYPE([goOOoDesktop])!="O")  OR  ISNULL( goOOoDesktop )
		PUBLIC goOOoDesktop
		goOOoDesktop = OOoServiceManager_CreateInstance( "com.sun.star.frame.Desktop" )
	ENDIF
	RETURN goOOoDesktop
	ENDFUNC
	
*   .	Return an instance of com.sun.star.reflection.CoreReflection. Cache it in a global variable. Create it if not already cached.
FUNCTION OOoGetCoreReflection()
	IF (TYPE([goOOoCoreReflection])!="O")  OR  ISNULL( goOOoCoreReflection )
		PUBLIC goOOoCoreReflection
		goOOoCoreReflection = OOoServiceManager_CreateInstance( "com.sun.star.reflection.CoreReflection" )
	ENDIF
	RETURN goOOoCoreReflection
	ENDFUNC
	
*   . Create a UNO struct object and return it.
FUNCTION OOoCreateStruct( cTypeName )

	*   . Ask service manager for a CoreReflection object.
	LOCAL oCoreReflection
	oCoreReflection = OOoGetCoreReflection()
	
	*  . Get the IDL Class for the type name.
	LOCAL oXIdlClass
	oXIdlClass = .NULL.
	
	LOCAL cOldErrHandler
	cOldErrHandler = ON( "ERROR" )
	ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
	oXIdlClass = oCoreReflection.forName( cTypeName )
	
	ON ERROR &cOldErrHandler
	IF ISNULL( oXIdlClass )
		=__OOoReleaseCachedVars()
		oCoreReflection = OOoGetCoreReflection()
		oXIdlClass 		= oCoreReflection.forName( cTypeName )
	ENDIF
	
	*    . Create a variable to hold the created Struct. Assign it some initial value.
	LOCAL oStruct
	oStruct = CREATEOBJECT( "relation" ) && assign some kind of object initially
	
	* Ask the class definition to create an instance.
	oXIdlClass.CreateObject( @oStruct )
	RETURN oStruct
	ENDFUNC
	
*      !!! Create a com.sun.star.beans.PropertyValue struct and return it.
FUNCTION OOoPropertyValue( cName, uValue, nHandle, nState )
	LOCAL oPropertyValue
	
	*	 
	oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
	
	*	  .
	oPropertyValue.Name = cName
	oPropertyValue.Value = uValue
	
	IF TYPE([nHandle])="N"
		oPropertyValue.Handle = nHandle
	ENDIF
	
	IF TYPE([nState])="N"
		oPropertyValue.State = nState
	ENDIF
	RETURN oPropertyValue
	ENDFUNC
	
*	     .	
FUNCTION OOoOpenURL( cURL )
	LOCAL ARRAY aNoArgs[1]
	aNoArgs[1] = OOoPropertyValue( "ReadOnly", .F. )
	
	LOCAL oDesktop
	oDesktop = OOoGetDesktop()
	
	LOCAL oDoc
	oDoc = oDesktop.LoadComponentFromUrl( cURL, "_blank", 0, @ aNoargs )	&&  COMARRAY( oDoc, 10 ) && ,      com-,  vfp v5  
	RETURN oDoc
	ENDFUNC
	
*	   	
PROCEDURE __OOoReleaseCachedVars()
	RELEASE goOOoServiceManager, goOOoDesktop, goOOoCoreReflection
	ENDPROC
	
*      URL  . Convert a local filename to an OOo URL. 
FUNCTION OOoConvertToURL( cFilename ) 

   * Ensure leading slash. 
   IF LEFT( cFilename, 1 ) != "/" 
      cFileName = "/" + cFileName 
   ENDIF 
   
   LOCAL cURL 
   cURL = CHRTRAN( cFilename, "\", "/" )   && change backslashes to forward slashes. 
   cURL = "file://" + cURL 
   RETURN cURL 
   ENDFUNC




**************************************************************************************************
*	   Writer
* ------------------------------------------------------------------------------------------------	
#define ooNumberingTypeARABIC     4  && Numbering is in Arabic numbers as "1, 2, 3, 4, ..."
#define ooFontSlantNONE           0  && specifies a font without slant
#define ooFontSlantITALIC         2  && specifies an italic font (slant designed into the font)
#define ooFontWeightNORMAL        100.000000  && specifies a normal font weight.
#define ooFontWeightBOLD          150.000000  && specifies a 150% font weight.
#define ooParagraphAdjustLEFT     0  && adjusted to the left border
#define ooParagraphAdjustBLOCK    2  && adjusted to both borders / stretched, except for last line
#define ooParagraphAdjustCENTER   3  && adjusted to the center
#define ooParagraphAdjustSTRETCH  4  && adjusted to both borders / stretched, including last line
#define ooTextContentAnchorTypeAS_CHARACTER 1  && The object is anchored instead of a character

*--   
#define vbHourglass 11
#define vbDefault 0

PROCEDURE VfpWriterExample()
	LOCAL oDesktop, cURL, aFileProperties[2], oDoc, oSheet, lcOOoVesion, oView, laArgs[1]

	*--  
	If AT("LibOOo", SET("PROCEDURE")) = 0  
		SET PROCEDURE TO LibOOo ADDITIVE  
	EndIf 

	*--    OpenOffice.org  
	If OOoIsInstalled()
		WAIT WINDOW NOWAIT " OpenOffice.org Calc. ..."
	Else
		=MessageBox(' OpenOffice.org     !',48,'  ')
		Return .F.
	EndIf

	*--     " "
	*_SCREEN.MousePointer = vbHourglass

	*--    Writer
	oDesktop = OOoGetDesktop()
	cURL = "private:factory/swriter"
	aFileProperties[1] = OOoPropertyValue( "Hidden", .T. )
	aFileProperties[2] = OOoPropertyValue( "ReadOnly", .F. )
	oDoc = oDesktop.LoadComponentFromUrl( cURL, "_blank", 0, @ aFileProperties )

	*--     "ArabicNumbering1"   
	*--       Writer     "Module1"
	sBasicModuleName = "Module1"  

	*--     StarBasic   sBasicModule    ,  VFP  .
	*--         VFP
	*--   (      !)   OpenOffice VFP    ,
	*--      ,   ,  
	*--         VFP  
	*-- ,       
	*--  Automation Bridge!        .
	TEXT TO sBasicModule NOSHOW
		REM  *****  BASIC  *****
		REM  (c) 24.07.2007 Roman V.Koltsov, Tambov, Russia
		REM  mailto: rvc44@rambler.ru, ICQ: 44612299,
		REM  phones: +7 (905) 1223500, +7 (910) 7541000
	
		Sub Main
			Dim oDoc, oFamilies, oNumStyles, sStyleName, iNumberingType, oStyle
			
			'    
			oDoc = ThisComponent
			
			'     
			oFamilies = oDoc.getStyleFamilies()
			
			'      
			oNumStyles = oFamilies.getByName("NumberingStyles")
			
			'   
			sStyleName = "ArabicNumbering1"
			
			'      
			iNumberingType = com.sun.star.style.NumberingType.ARABIC
			
			'    NumberingType  ParentNumbering
			oStyle 		= oNumStyles.getByName(sStylename)
			oNumRules 	= oStyle.NumberingRules
			
			For j = 0 to oNumRules.GetCount() - 1
				mLevel = oNumRules.getByIndex(j)
				For i = LBound(mLevel) To UBound(mLevel)
					vProperty = mLevel(i)
					If (vProperty.Name = "NumberingType") Then
						vProperty.Value = iNumberingType
					End If
					If (vProperty.Name = "ParentNumbering") Then
						vProperty.Value = 3
					End If
					mLevel(i) = vProperty
				Next i
				
				oNumRules.replaceByIndex(j, mLevel)
			Next j
			oStyle.NumberingRules = oNumRules
		End Sub
	ENDTEXT

	*--      ()    Writer
	oLibrary = oDoc.BasicLibraries.GetByName("Standard") 
	oLibrary.InsertByName(sBasicModuleName, sBasicModule)	

	*-- Get the document's current controller.    .
	oView = oDoc.getCurrentController()

	*-- Get the document's frame
	oFrame = oView.getFrame()

	*--   Writer'      
	oWindow = oFrame.getContainerWindow()
	oWindow.SetVisible(.F.)

	oText 	= oDoc.getText()
	oCursor = oText.createTextCursor()

	*--     
	oDocInfo = oDoc.getDocumentInfo()

	*--     
	oDocDate = oDocInfo.CreationDate

	*--        
	sDate = PadL(AllT(Str(oDocDate.Day)),2,'0')+'.'+PadL(AllT(Str(oDocDate.Month)),2,'0')+'.'+PadL(AllT(Str(oDocDate.Year)),4,'0')  && DateSerial(oDocDate.Year, oDocDate.Month, oDocDate.Day)
	sTime = PadL(AllT(Str(oDocDate.Hours)),2,'0')+':'+PadL(AllT(Str(oDocDate.Minutes)),2,'0')+':'+PadL(AllT(Str(oDocDate.Seconds)),2,'0')  && TimeSerial(oDocDate.Hours, oDocDate.Minutes, oDocDate.Seconds)

	*--      
	oFamilies = oDoc.getStyleFamilies()

	*--   ,    
	sPageStyleName = oCursor.PageStyleName
	oPageStyles = oFamilies.getByName("PageStyles")
	oStyle = oPageStyles.getByName(sPageStyleName)
	oStyle.LeftMargin = 3000
	oStyle.TopMargin = 2000
	oStyle.RightMargin = 1500
	oStyle.BottomMargin = 2000

	*--       
	oNumStyles = oFamilies.getByName("NumberingStyles")

	*--     
	sStyleName = "ArabicNumbering1"  &&    , , "Numbering 5".    !

	*--       
	*--  VFP   : oNumRules.replaceByIndex(lJ-1, @ mLevel)
	*--   mLevel   list-of-list.  !!!
	iNumberingType = ooNumberingTypeARABIC  && com.sun.star.style.NumberingType.ARABIC

	*--       ,   " "
	If !oNumStyles.HasByName(sStyleName)
	
		*--   " "
		oStyle = oDoc.createInstance("com.sun.star.style.NumberingStyle")
		
		*-- save style in order to set all properties
		oNumStyles.insertByName( sStyleName, oStyle )
	EndIf

	*--    ,     
	oParaStyles = oFamilies.getByName( "ParagraphStyles" )
	
	If !oParaStyles.HasByName( sStyleName )
	
		*-- create paragraph style here
		oStyle = oDoc.createInstance("com.sun.star.style.ParagraphStyle")
		oStyle.ParentStyle = "Standard"  && ""
		oStyle.FollowStyle = sStyleName
		oStyle.ParaOrphans = 3  && specifies the minimum number of lines of the paragraph that have to be at bottom of a page if the paragraph is spread over more than one page.
		oStyle.ParaWidows = 3   && specifies the minimum number of lines of the paragraph that have to be at top of a page if the paragraph is spread over more than one page. 
		oStyle.ParaTopMargin = 200  && determines the top margin of the paragraph in 100th mm.
		oStyle.ParaBottomMargin = 200  && determines the bottom margin of the paragraph in 100th mm.
		oStyle.ParaLeftMargin = 200  && determines the left margin of the paragraph in 100th mm.
		oStyle.ParaAdjust = ooParagraphAdjustBLOCK  && com.sun.star.style.ParagraphAdjust.BLOCK
		oStyle.NumberingStyleName = sStyleName
		oParaStyles.insertByName( sStyleName, oStyle )
	EndIf

	*--   ,   
	oTextRange = oText.getEnd()  && oText.getStart()
	
	*--     ,       ():
	oTextRange.ParaStyleName = "Standard"  && "";   :  "Heading 4" <=> " 4" ; "Numbering 1"  <=> " 1"
	oTextRange.ParaAdjust = ooParagraphAdjustCENTER  && com.sun.star.style.ParagraphAdjust.CENTER

	*--   
*	sFileName = [Gerb.bmp]
	sConvFileName = [C:\] + sFileName
	cURL = "file:///" + CHRTRAN( sConvFileName, "\", "/" )  && OOoConvertToURL( sConvFileName )

	*--  2      OPENOFFICE WRITER
	*-- 2.       .      !
	If File(sConvFileName)
		oGraphicObject = oDoc.createInstance("com.sun.star.drawing.GraphicObjectShape")

		*-- Set URL to the graphic.
		oGraphicObject.GraphicURL = cURL
		
		*-- Assuming a text document, add it to the single draw page.
		oDoc.getDrawpage().add(oGraphicObject)
	EndIf

	*--   
	oSize = OOoCreateStruct( "com.sun.star.awt.Size" )
	oSize.Width = 1770  &&   1/100 
	oSize.Height = 2220  &&   1/100 
	oGraphicObject.Size = oSize  && oGraphicObject.setSize(oSize)

	oTextRange.CharFontName = "Times New Roman"
	oTextRange.CharHeight = 14.00
	oTextRange.CharPosture = ooFontSlantNONE  && com.sun.star.awt.FontSlant.NONE
	oTextRange.CharWeight = ooFontWeightBOLD  && com.sun.star.awt.FontWeight.BOLD
	
	*--    
*	oTextRange.CharColor = OOoRGB(0,0,0)      &&  : OOoRGB(0,0,255)
	oTextRange.setString ( Chr(13)+Chr(13)+"    "+Chr(10)+" "+Chr(13) )
	oTextRange = oText.getEnd()
	oTextRange.CharHeight = 18.00
	oTextRange.setString ( Chr(13)+"          "+Chr(13) )

	oTextRange = oText.getEnd()
	oTextRange.CharHeight = 12.00
	oTextRange.CharWeight = ooFontWeightNORMAL      && com.sun.star.awt.FontWeight.NORMAL
	oText.insertString(oCursor, Chr(13)+". "+Chr(13)+Chr(13)+Chr(13), .F.)
	oTextRange = oText.getEnd()
	oTextRange.ParaAdjust = ooParagraphAdjustBLOCK  && com.sun.star.style.ParagraphAdjust.BLOCK
	oText.insertString(oCursor, "        "+Chr(10), .F.)
	oText.insertString(oCursor, "     "+Chr(10), .F.)
	oText.insertString(oCursor, "   ,  "+Chr(10), .F.)
	oText.insertString(oCursor, "            :"+Chr(13), .F.)

	*-- Restart the numbering
	oCursor.NumberingStartValue = 1  && specifies the start value for numbering if a new numbering starts at this paragraph

	*--    sStyleName
	oTextRange = oText.getEnd()
	oTextRange.ParaStyleName = sStyleName
	oTextRange.ParaAdjust = ooParagraphAdjustBLOCK  && com.sun.star.style.ParagraphAdjust.BLOCK
	oTextRange.CharFontName = "Times New Roman"  && ,    Prof: Arial
	oTextRange.CharHeight = 12.00
	oTextRange.CharPosture = ooFontSlantNONE   && com.sun.star.awt.FontSlant.NONE
	oTextRange.CharWeight = ooFontWeightNORMAL && com.sun.star.awt.FontWeight.BOLD

	oCursor.NumberingLevel = 0  && specifies the numbering level of the paragraph
	oText.insertString(oCursor, "      "+Chr(10), .F.)
	oText.insertString(oCursor, "   ,  "+Chr(10), .F.)
	oText.insertString(oCursor, "    :"+Chr(13), .F.)

	******************************************************
	*--       
	oCursor.NumberingLevel = 1
	oText.insertString(oCursor, " "+Chr(13), .F.)

	oCursor.NumberingLevel = 2
	m.lcReceiver = "   (1000001)"
	m.lcReceiver = m.lcReceiver + "   " + "01.01.2003" + "  ,  "
	m.lcReceiver = m.lcReceiver + "   "
	m.lcReceiver = m.lcReceiver + ",  "+"01.09.2007"+ ;
				   "   " + "70" + "%     "+ ;
				   "      ;"
	oText.insertString(oCursor, m.lcReceiver+Chr(13), .F.)

	oCursor.NumberingLevel = 1
	oText.insertString(oCursor, " "+Chr(13), .F.)

	oCursor.NumberingLevel = 2
	m.lcReceiver = "   (2000001)"
	m.lcReceiver = m.lcReceiver + "   " + "01.06.2004" + "  ,  "
	m.lcReceiver = m.lcReceiver + "   "
	m.lcReceiver = m.lcReceiver + ",  "+"01.06.2007"+ ;
				   "   " + "50" + "%     "+ ;
				   "      ;"
	oText.insertString(oCursor, m.lcReceiver+Chr(13), .F.)
	******************************************************

	oCursor.NumberingLevel = 0
	oText.insertString(oCursor, "       ."+Chr(13), .F.)

*	DO pcdone

	*--     Microsoft Word.    OpenOffice    ,   MS!!!
	*--   ,        .    !
	sFileName = [Order.doc]
	sConvFileName = [C:\] + sFileName
	cURL = "file:///" + CHRTRAN( sConvFileName, "\", "/" )  && OOoConvertToURL( sConvFileName )
	laArgs[1] = OOoPropertyValue("FilterName", "MS Word 97")
	oDoc.storeAsURL(cURL, @laArgs)

	*--    
	oWindow.SetVisible(.T.)

	*--    ,     
	lsWinTitle = oFrame.getPropertyValue("Title")

	*--   Writer   .      Windows 98!
*	TRY
*		loShell = CreateObject("WScript.Shell")
*		loShell.AppActivate(lsWinTitle)
*		loShell.SendKeys("")  && . http://forum.foxclub.ru/read.php?29,252421,252421#msg-252421
*		CATCH
*	ENDTRY

	_SCREEN.MousePointer = vbDefault

	*--             "javascript". ,  VFP  ...  -  !
	*--  ,    : The VARIANT does not contain an object type!..
	LOCAL sMacroURL, oScr, oVarArray
	oScr = CreateObject("MSScriptControl.ScriptControl")
	oScr.Language = "javascript"
	oScr.Eval("Arr = new Array()")
	oVarArray = oScr.Eval("Arr")

	*--   Main   Module1  Standard  ,    Order
	sMacroURL = "macro://Order/Standard.Module1.Main"  &&  "macro://./Standard.Module1.Main"  && MacroExecutionMode = com.sun.star.document.MacroExecMode.ALWAYS_EXECUTE_NO_WARN
	oDispatcher = OOoServiceManager_CreateInstance("com.sun.star.frame.DispatchHelper")
	oDispatcher.executeDispatch(oDesktop, sMacroURL, "", 0, oVarArray)  &&  OOoRunMacro!!!

	*--     
	oViewCursor = oView.getViewCursor()
	oViewCursor.jumpToFirstPage()
	oViewCursor.jumpToStartOfPage()
	
	*--   10  
	oViewCursor.goDown( 10, .F. )
	
	*--    
	oViewCursor.gotoStartOfLine( .F. )

	*--   ,  ,      
	If (oDoc.hasLocation() And (Not oDoc.isReadOnly()))
		oDoc.store()
	EndIf

	*  Public-     RPC   
	RELEASE goOOoDesktop, goOOoConfigProvider

	WAIT CLEAR








  

*    Calc.   (c) DannyB Thu Apr 08, 2004 7:30 am
PROCEDURE VfpCalcExample2()
LOCAL oDesktop, cURL, aFileProperties[2], oDoc, oSheet, lcOOoVesion, oCalcCtrl

   *--  
   If AT("LibOOo", SET("PROCEDURE")) = 0  
      SET PROCEDURE TO LibOOo ADDITIVE  
   EndIf 

   *--    OpenOffice.org  
   If OOoIsInstalled()
	   WAIT WINDOW NOWAIT " OpenOffice.org Calc. ..."
   Else
	   =MessageBox(' OpenOffice.org     !',48,'  ')
	   Return .F.
   EndIf

   *--    OpenOffice.org Calc,     
   *--    OOoOpenURL("private:factory/scalc"),      (Hidden)!
   ***********************
   *--    , :
   *-- cURL = "file:///" + CHRTRAN( sFileName, "\", "/" ),  sFileName      
   *-- aFileProperties[2] = OOoPropertyValue( "FilterName", "MS Excel 97" )
   oDesktop = OOoGetDesktop()
   cURL = "private:factory/scalc"
   aFileProperties[1] = OOoPropertyValue( "Hidden", .T. )
   aFileProperties[2] = OOoPropertyValue( "ReadOnly", .F. )
   oDoc = oDesktop.LoadComponentFromUrl( cURL, "_blank", 0, @ aFileProperties )
    
   *--       
   oSheet = oDoc.getSheets().getByIndex( 0 ) 

   *--   OpenOffice.org
*   lcOOoVesion = OOoVersion()
 
   *--        
   oCalcCtrl = oDoc.getCurrentController()  &&       oView

   *--     ,  Title      
   oFrame = oCalcCtrl.getFrame()

   *--   Calc'      
   oWindow = oFrame.getContainerWindow()
   oWindow.SetVisible(.F.)

   *--     
   *--    
   oCalcCtrl.ShowGrid = .T.  &&  Excel .ActiveSheet.PageSetup.PrintGridlines = .T.
   *--    100%
   oCalcCtrl.ZoomType = ooDocumentZoomTypeBY_VALUE
   oCalcCtrl.ZoomValue = 100
   *--     ( Excel: .ActiveWindow.DisplayZeros = .f.)
   *-- ->->OpenOffice.org Calc->->-> ->.F.
   oCalcCtrl.ShowZeroValues = .F.
   *--         , ..  
   *-- ->->OpenOffice.org Calc->->-> ->.F.
   oCalcCtrl.ShowNotes = .F.
   *--      
   *-- ->->OpenOffice.org Calc->->->   ->.T.
   oCalcCtrl.HasColumnRowHeaders = .T.
   *--     Calc (sheet tabs)
   *-- ->->OpenOffice.org Calc->->-> ->.T.
   oCalcCtrl.HasSheetTabs = .T.
   *--     
   oCalcCtrl.HideSpellMarks = .T.
   *--    
   *-- ->->OpenOffice.org Calc->-> -> ->.T.
   oCalcCtrl.ShowPageBreaks = .T.
 
   *----- 
   *      
   oSheet.getCellByPosition( 0, 0 ).setString( "" ) 
   oSheet.getCellByPosition( 1, 0 ).setString( "  " ) 
   oSheet.getCellByPosition( 2, 0 ).setString( "" ) 
    
   oSheet.getCellByPosition( 0, 1 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 2 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 3 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 4 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 5 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 6 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 7 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 8 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 9 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 10 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 11 ).setString( "" ) 
   oSheet.getCellByPosition( 0, 12 ).setString( "" ) 
    
   oSheet.getCellByPosition( 1, 1 ).setValue( 3826.37 ) 
   oSheet.getCellByPosition( 1, 2 ).setValue( 3504.21 ) 
   oSheet.getCellByPosition( 1, 3 ).setValue( 2961.45 ) 
   oSheet.getCellByPosition( 1, 4 ).setValue( 2504.12 ) 
   oSheet.getCellByPosition( 1, 5 ).setValue( 2713.98 ) 
   oSheet.getCellByPosition( 1, 6 ).setValue( 2448.17 ) 
   oSheet.getCellByPosition( 1, 7 ).setValue( 1802.13 ) 
   oSheet.getCellByPosition( 1, 8 ).setValue( 2203.22 ) 
   oSheet.getCellByPosition( 1, 9 ).setValue( 1502.54 ) 
   oSheet.getCellByPosition( 1, 10 ).setValue( 1207.68 ) 
   oSheet.getCellByPosition( 1, 11 ).setValue( 1819.71 ) 
   oSheet.getCellByPosition( 1, 12 ).setValue( 986.03 ) 
    
   oSheet.getCellByPosition( 2, 1 ).setFormula( "=DATE(2004;01;31)" ) 
   oSheet.getCellByPosition( 2, 2 ).setFormula( "=DATE(2004;02;29)" ) 
   oSheet.getCellByPosition( 2, 3 ).setFormula( "=DATE(2004;03;31)" ) 
   oSheet.getCellByPosition( 2, 4 ).setFormula( "=DATE(2004;04;30)" ) 
   oSheet.getCellByPosition( 2, 5 ).setFormula( "=DATE(2004;05;31)" ) 
   oSheet.getCellByPosition( 2, 6 ).setFormula( "=DATE(2004;06;30)" ) 
   oSheet.getCellByPosition( 2, 7 ).setFormula( "=DATE(2004;07;31)" ) 
   oSheet.getCellByPosition( 2, 8 ).setFormula( "=DATE(2004;08;31)" ) 
   oSheet.getCellByPosition( 2, 9 ).setFormula( "=DATE(2004;09;30)" ) 
   * Note that these last three dates are not set as DATE() function calls. 
   oSheet.getCellByPosition( 2, 10 ).setFormula( "10/31/2004" ) 
   oSheet.getCellByPosition( 2, 11 ).setFormula( "11/30/2004" ) 
   oSheet.getCellRangeByName( "C13" ).setFormula( "12/31/2004" ) 
   *----- 

   *--   aAddress    /
*   aAddress = OOoGetLastUsedCel( oSheet )
   nFirstColumn = 0
   nFirstRow    = 0
   *--     OpenOffice Calc (  0!)
   nLastRow = aAddress.EndRow  &&  Excel .ActiveSheet.UsedRange.Rows.Count
   *--     OpenOffice Calc (  0!)
   nLastColumn = aAddress.EndColumn  &&  Excel  .ActiveSheet.UsedRange.Columns.Count
    
   *--     ,       
   oFormats = oDoc.getNumberFormats()
   oLocale = OOoCreateStruct( "com.sun.star.lang.Locale" )
   With oLocale
      .Language = "ru"  && "en"
      .Country = "RU"  && "US"
   EndWith

   *--      Calc. 
   oColumns = oSheet.getColumns() 

   *--         ... 
   For nCol = nFirstColumn To nLastColumn 
      *--      
      oColumn = oColumns.getByIndex( nCol ) 
	  oRange = oSheet.getCellRangeByPosition(nCol,1,nCol,nLastRow)

      *--      
      Do Case
          Case nCol = 0  &&  "A"
              oColumn.Width = 2190  && 2.19 cm
              * oRange = oSheet.getCellRangeByName( "A2:A13" )
              oRange.NumberFormat = oFormats.getStandardFormat( ooNumberFormatTEXT, oLocale )
          Case nCol = 1  &&  "B"
              oColumn.Width = 6870  && 6.87 cm
              * oRange = oSheet.getCellRangeByName( "B2:B13" )
              oRange.NumberFormat = oFormats.getStandardFormat( ooNumberFormatNUMBER, oLocale )
          Case nCol = 2  &&  "C"
              oColumn.Width = 7100  && 7.10 cm
              * oRange = oSheet.getCellRangeByName( "C2:C13" ) 
              oRange.NumberFormat = oFormats.getStandardFormat( ooNumberFormatDATE, oLocale )   && ooNumberFormatDATE = com.sun.star.util.NumberFormat.DATE = 2 
      EndCase
   EndFor

   *--     lnIndent 
   m.lnIndent = 4
   oSheet.GetRows().InsertByIndex(0, m.lnIndent)

   *--     
   LOCAL oBorderLine, oCells
   oBorderLine = OOoCreateStruct( "com.sun.star.table.BorderLine" )
   With oBorderLine
	   .Color = 0
	   .InnerLineWidth =  0  &&      
	   .OuterLineWidth = 25  &&      
	   .LineDistance = 0 
   EndWith
   oCells = oSheet.getCellRangeByPosition(nFirstColumn, nFirstRow+m.lnIndent, nLastColumn, nFirstRow+m.lnIndent)
   oCells.LeftBorder   = oBorderLine
   oCells.RightBorder  = oBorderLine
   oCells.TopBorder    = oBorderLine
   oCells.BottomBorder = oBorderLine
   *--   
   oCells.charFontName="Arial"
   *--   
   oCells.charHeight = 10  &&    , , "10"
   *--   
   oCells.charWeight = 150  &&    100,   150
   *--   WrapText,        
   oCells.IsTextWrapped  = .T.
   *-- ,         () AlexRayne, 25.05.07
   oSheet.Rows.OptimalHeight = .T.
   *--    
   oCells.HoriJustify = ooCellHoriJustifyCENTER

   LOCAL oPageStyles, oPageSetup, oPageNumber, oPageCount, oDate, oTime, oHeader, oFooter, oCursor
   oPageStyles = oDoc.StyleFamilies.getByName("PageStyles")  && oDoc.getStyleFamilies().getByName( "PageStyles" )
   oPageSetup = oPageStyles.getByName(oSheet.PageStyle)  &&  oPageStyles.getByName("Default"), ..  : 

   *-- Get page number and page count objects.
   oPageNumber = oDoc.createInstance( "com.sun.star.text.TextField.PageNumber" )
   oPageCount  = oDoc.createInstance( "com.sun.star.text.TextField.PageCount" )
   oDate   	= oDoc.createInstance( "com.sun.star.text.TextField.Date" )
   oTime   	= oDoc.createInstance( "com.sun.star.text.TextField.Time" )
   With oPageSetup
       .ScaleToPagesX = 1	   &&  .FitToPagesWide  Excel
       .ScaleToPagesY = 1000   &&  .FitToPagesTall  Excel (10000    Windows 98)
       .IsLandscape = .T.	   && Page Orientation
       .Height = 21000		   &&      ,
       .Width = 29700		   &&     !
       .HeaderOn = .T.		   &&   
	   .FooterOn = .T.		   &&   
       .FooterShared = .T.	   &&    shared

       *--    
	   oHeader = .RightPageHeaderContent
	   oHeader.getLeftText().setString( "   OpenOffice.org v."+lcOOoVesion )
	   oHeader.getCenterText().setString( "" )
	   oHeader.getRightText().setString( " " )
	   oCursor = oHeader.getRightText().createTextCursor()
	   oCursor.gotoEnd( .F. )
	   oHeader.getRightText().insertTextContent( oCursor, oPageNumber, .T. )
	   oCursor.gotoEnd( .F. )
	   oCursor.setString( "  " )
	   oCursor.gotoEnd( .F. )
	   oHeader.getRightText().insertTextContent( oCursor, oPageCount, .T. )
	   .RightPageHeaderContent = oHeader

	   *--    
	   oFooter = .RightPageFooterContent
	   oFooter.getLeftText().setString( " " )
	   oFooter.getCenterText().setString( "" )
	   oFooter.getRightText().setString( " " )  && +TTOC(DATETIME())
	   oCursor = oFooter.getRightText().createTextCursor()
	   oCursor.gotoEnd( .F. )
	   oFooter.getRightText().insertTextContent( oCursor, oDate, .T. )
	   oCursor.gotoEnd( .F. )
	   oCursor.setString( Space(2) )
	   oCursor.gotoEnd( .F. )
	   oFooter.getRightText().insertTextContent( oCursor, oTime, .T. )
	   .RightPageFooterContent = oFooter

	   *--   
       .LeftMargin = 1500     &&  : oPage.setPropertyValue("LeftMargin", 500)
       .TopMargin = 1500      && 1500  1,5 
       .RightMargin = 1500
       .BottomMargin = 1500
   EndWith

   *--    3-  
   oRange = oSheet.GetCellRangeByPosition(0, 2, nLastColumn, 2)
   oRange.HoriJustify = ooCellHoriJustifyCENTER  && com.sun.star.table.CellHoriJustify CENTER
   oRange.Merge(.F.)
   oRange.Merge(.T.)
   oSheet.getCellByPosition(0, 2).SetString("    ")

   **********************************************
   *--      OOo CALC        STAR BASIC
   *-- (c) Roman V.Koltsov, Tambov, Russia. Thanks to Oliver Brinzing <OliverBrinzing@t-online.de>
   *-- http://api.openoffice.org/servlets/BrowseList?list=dev&by=thread&from=33975
   *-- Helpfull hint for this solution is here: http://www.oooforum.org/forum/viewtopic.phtml?t=10431
   *-- How to change a push button text/caption: http://www.oooforum.org/forum/viewtopic.phtml?t=46635
   *-- Handy adding a pushbutton to a sheet: http://www.openofficetips.com/blog/archives/2004/09/controls_pushbu.html
   *-- Problem in switching Design Mode On/Off: http://www.oooforum.org/forum/viewtopic.phtml?t=13986
   *-- Design Mode On/Off via Dispatch API: http://www.mail-archive.com/dev@api.openoffice.org/msg04011.html
   *--     OOoSetDesignMode,   " ",  :
   *-- http://forum.foxclub.ru/read.php?29,279187,280976#msg-280976
   Local oPosition, oSize, oForm, oDrawPage, oControlShape, oControlModel, oController, ;
	     sBasicModule, sBasicModuleName, oLibrary, oEvents[1]

   *-- create a form..
   oForm = oDoc.createInstance( "com.sun.star.form.component.Form" )  && createUnoService("com.sun.star.form.component.DataForm")

   *-- get the drawpage of the first sheet and insert the form there.. 
   oDrawPage = osheet.getDrawPage() 
   oDrawPage.Forms.insertByName("MyForm", oForm)  && If created handy, name is "Standard" 

   *-- now create a Shape that will visualize the Buttonmodel 
   oControlShape = oDoc.createInstance( "com.sun.star.drawing.ControlShape" )

   *-- Position of it.. 
   oPosition = OOoCreateStruct( "com.sun.star.awt.Point" )
   oPosition.X = 0
   oPosition.Y = 0
   oControlShape.Position = oPosition  && oControlShape.setPosition(oPosition)
   * oControlShape.MoveProtect = .T.

   *-- Size of it.. 
   oSize = OOoCreateStruct( "com.sun.star.awt.Size" )
   oSize.Width = 3667 && 900  && 3000  && 108 
   oSize.Height = 853 && 853  && 1600  && 60
   oControlShape.Size = oSize && oControlShape.setSize(oSize)
   * oControlShape.SizeProtect = .T.

   * oControlShape.setPropertyValue("AnchorType",com.sun.star.text.TextContentAnchorType.AT_PAGE) 
   * oControlShape.Name("MyShape")

   *-- now create a simple button for it.. 
   oControlModel = oDoc.createInstance( "com.sun.star.form.component.CommandButton" )
   oControlModel.Name = "CmdButton"  && If created handy, button name is "PushButton"
   oControlModel.Label = "  " 
   oControlModel.Align = 1
   oControlModel.DefaultButton = .F.
   oControlModel.Enabled = .T.
   oControlModel.FocusOnClick = .T.
   oControlModel.HelpText = "      "
   oControlModel.HelpURL = ""
   oControlModel.ImageAlign = 1
   oControlModel.ImagePosition = 12
   oControlModel.ImageURL = ""
   oControlModel.Printable = .T.
   oControlModel.PushButtonType = 0
   oControlModel.State = 0
   oControlModel.Toggle = .F.
   oControlModel.FontName = "MS Sans Serif"
   oControlModel.FontHeight = 8
   *oControlModel.Tag = "Any text"
   *oControlModel.BackgroundColor
   *oControlModel.TextColor
   *oControlModel.TextLineColor
   *oControlModel.FontDescriptor.Name = "MS Sans Serif"

   *-- now connect model and shape with each other 
   oControlShape.Control = oControlModel  && oControlShape.setControl(oControlModel)

   *-- now insert it into the form.. 
   oDrawPage.Forms.getByName("MyForm").insertByIndex(0, oControlModel) 

   *-- now add it to the drawpage so that it becomes visible.. 
   oDrawPage.add(oControlShape)

   *-- set the focus to the first control
   oController = oCalcCtrl.getControl(oControlModel)  && oCalcCtrl.getControl(oForm.getByIndex(0)).setFocus()
   oController.setFocus()

   *-- Programmatically adding macros to current document by creating "Module1" and its body
   *-- http://www.oooforum.org/forum/viewtopic.phtml?t=991
   sBasicModuleName = "Module1"  
   *--   : ConvertFromURL(sDocURL),  sDocURL = Thiscomponent.URL
   *--  : DirectoryNameoutofPath(sDocURL, "/")
   *--  : GetFileNameExtension(sDocUrl)
   *--    : FileNameoutofPath(sDocURL, "/")
   *--    : GetFileNameWithoutExtension(sDocUrl, "/")
   sBasicModule =  'REM  *****  BASIC  *****' + Chr(10)+;
				   'REM  (c) 29.06.2007 Roman V.Koltsov, Tambov, Russia' + Chr(10)+;
				   'REM  mailto: rvc44@rambler.ru, ICQ: 44612299,' + Chr(10)+;
				   'REM  phones: +7 (905) 1223500, +7 (910) 7541000' + Chr(10) + Chr(10)+;
				   'Sub Main' + Chr(10)+;
				   '	Dim oDoc, aNoArg(), sDocURL$, sNewUrl$, sFileName$' + Chr(10)+;
				   '	oDoc = ThisComponent' + Chr(10)+;
				   '	If Not GlobalScope.BasicLibraries.isLibraryLoaded("Tools") Then' + Chr(10)+;
				   '		GlobalScope.BasicLibraries.LoadLibrary("Tools")' + Chr(10)+;
				   '	End If' + Chr(10)+;
				   '	If (oDoc.hasLocation()) Then' + Chr(10)+;
				   '		sDocURL = oDoc.getURL()' + Chr(10)+;
				   '		sFileName = FileNameoutofPath(sDocURL, "/")' + Chr(10)+;
				   '		MsgBox "      OK    " & _' + Chr(10)+;
				   '			   Chr(10) & " " & sFileName & "  ", 64, "OpenOffice.org Calc"' + Chr(10)+;
				   '		sNewUrl = ConvertToURL( "file:///" & "A:/" & sFileName )' + Chr(10)+;
				   '		oDoc.storeAsURL( sNewUrl, aNoArg() )' + Chr(10)+;
				   '		MsgBox "  !", 64, "OpenOffice.org Calc"' + Chr(10)+;
				   '	End If' + Chr(10)+;
				   'End Sub' + Chr(10)

   *-- Add Code Module
   oLibrary = oDoc.BasicLibraries.GetByName("Standard") 
   oLibrary.InsertByName(sBasicModuleName, sBasicModule)

   oEvents[1] = OOoCreateStruct( "com.sun.star.script.ScriptEventDescriptor" )
   oEvents[1].ListenerType = "XActionListener"  && listener type as string, same as listener-XIdlClass.getName()  && "com.sun.star.awt.XItemListener"
   oEvents[1].EventMethod = "actionPerformed"   && event method as string  && "itemStateChanged"
   oEvents[1].AddListenerParam = ""             && data to be used if the addListener method needs an additional parameter

   oEvents[1].ScriptType = "StarBasic"          && type of the script language as string; for example, "Basic" or "StarScript"
   oEvents[1].ScriptCode = "document:Standard.Module1.Main"  && script code as string (the code has to correspond with the language defined by ScriptType)
   *-- Method registerScriptEvent(nIndex, aScriptEvent) of interface com.sun.star.script.XEventAttacherManager
   *-- Interface registers listeners for specified events and
   *-- method registers one event for an object identified by its index.
   *-- If any object is attached under this index, then this event is attached automatically.
   oForm.registerScriptEvent(0,oEvents[1])

   *--  ,  ,    Calc  
   *--    - " ", 
   *--   ->  ->  ->  
   *--      oDoc.ApplyFormDesignMode = .F.
   *--  oDoc.setPropertyValue( "ApplyFormDesignMode", 0 ), ..   
   *--  API     2.2   ,    
   *--    : http://www.mail-archive.com/dev@api.openoffice.org/msg04011.html
*   OOoSetDesignMode(oDoc, .F.)
   **********************************************

   LOCAL ARRAY aOneArg[1] 
   LOCAL cFile, cURL 
    
*   cFile = GetDesktopFolderPathname()+"example" 
   cFile = "c:\example" 

   *      OpenOffice.org Calc. 
   cURL = "file:///" + CHRTRAN( cFile, "\", "/" ) + ".sxw"  && OOoConvertToURL( cFile + ".sxw" ) 
   aOneArg[1] = OOoPropertyValue( "Overwrite", .T. ) 
   oDoc.storeToUrl( cURL, @ aOneArg ) 
    
   *     Microsoft Excel.    OpenOffice    ,   MS!!!
   cURL = "file:///" + CHRTRAN( cFile, "\", "/" ) + ".xls"  && OOoConvertToURL( cFile + ".xls" ) 
   aOneArg[1] = OOoPropertyValue( "FilterName", "MS Excel 97" ) 
   oDoc.storeAsUrl( cURL, @ aOneArg ) 
 
   *--    
   oWindow.SetVisible(.T.)

   *--    ,     
   lsWinTitle = oFrame.getPropertyValue("Title")

   *--   Calc   .      Windows 98,  TRY!
*   TRY
*	   loShell = CreateObject("WScript.Shell")
*	   loShell.AppActivate(lsWinTitle)
*	   loShell.SendKeys("")  && . http://forum.foxclub.ru/read.php?29,252421,252421#msg-252421
*   CATCH
*   ENDTRY

   *  Public-     RPC   
   RELEASE goOOoDesktop, goOOoConfigProvider

   WAIT CLEAR
    
   * Close the document. 
*   oDoc.close( 1 ) && TRUE 
ENDPROC